/**
 * Formats [DATE] UNIX Timestamps (without time) to readable strings
 * @public
 */
export declare function formatDateTimestamp(timestamp: number): string;
/**
 * Formats [DATETIME] UNIX Timestamps (with time) to readable strings
 * @public
 */
export declare function formatDateTimeTimestamp(timestamp: number): string;
/**
 * Formats [DATE|DATETIME] Unix Timestamps to readable strings
 * @public
 * @param timestamp - The UNIX Timestamp.
 * @param withTime - The flag to determine if formatted value should contain 'time' info.
 */
export declare function formatTimestamp(timestamp: number, withTime: boolean): string;
/**
 * @public
 */
export declare function getDateFormatter(locale?: string, options?: Intl.DateTimeFormatOptions): (params: any) => string;
//# sourceMappingURL=datetime.d.ts.map