/**
 * Resolve a promise after a timeout.
 *
 * @example
 * ```ts
 * const result = await Promise.race([
 *  resourceChecks(sourceRef, resource),
 *  resolveAfter<MonitoredResourceChecksResult>(this.config.checkTimeout, () => ({
 *    isConnected: false,
 *    lastUpdated: Date.now(),
 *   })),
 * ]);
 * ```
 *
 * @public
 */
export declare const resolveAfter: <T = any>(ms: number, valueCreator: () => T) => Promise<T>;
//# sourceMappingURL=resolveAfter.d.ts.map