import Numeral from 'numeral';
import 'numeral/locales';
/**
 * @public
 */
export function getNumberFormatter(format, locale) {
    return (params) => {
        // bigdecimals are sent as strings
        if (!(params && (typeof params.value === 'number' || typeof params.value === 'string'))) {
            return '';
        }
        if (locale) {
            Numeral.locale(locale);
        }
        return Numeral(params.value).format(format);
    };
}
