import { ElementStyles } from '@microsoft/fast-element';
/**
 * toElementStyles.
 * @remarks
 * Converts {@link @microsoft/fast-element#ComposableStyles} or a ComposableStyles array to {@link @microsoft/fast-element#ElementStyles}.
 * @param styles - ComposableStyles or a ComposableStyles array.
 * @public
 */
export function toElementStyles(styles) {
    if (!styles) {
        return;
    }
    if (Array.isArray(styles)) {
        return ElementStyles.create(styles);
    }
    if (styles instanceof ElementStyles) {
        return styles;
    }
    return ElementStyles.create([styles]);
}
