<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-utils](./foundation-utils.md)

## foundation-utils package

## Classes

|  Class | Description |
|  --- | --- |
|  [DefaultErrorMap](./foundation-utils.defaulterrormap.md) |  |
|  [DefaultServerRowDTOMapper](./foundation-utils.defaultserverrowdtomapper.md) | The default <code>ServerRowDTOMapper</code>. |
|  [InMemoryDatabase](./foundation-utils.inmemorydatabase.md) | An in memory database of specific DatabaseRecord types. |
|  [NumberParser](./foundation-utils.numberparser.md) |  |
|  [SlottedStyles](./foundation-utils.slottedstyles.md) | A custom element that encapsulates a set of styles that can be applied to slotted elements. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [FontStyle](./foundation-utils.fontstyle.md) | An enum of possible font styles. |
|  [FontWeight](./foundation-utils.fontweight.md) | An enum of possible font weights. |
|  [PendingStateEvents](./foundation-utils.pendingstateevents.md) | An enum that defines the names of the events that can be raised by the <code>PendingState</code> mixin. |

## Functions

|  Function | Description |
|  --- | --- |
|  [assureDesignSystem(module)](./foundation-utils.assuredesignsystem.md) | assureDesignSystem. |
|  [createLogger(name, options)](./foundation-utils.createlogger.md) | Creates a logger with the given name and options. |
|  [customNumberParser(value)](./foundation-utils.customnumberparser.md) | A Default Number Parser for deserializing objects. |
|  [formatDateTimestamp(timestamp)](./foundation-utils.formatdatetimestamp.md) | Formats \[DATE\] UNIX Timestamps (without time) to readable strings |
|  [formatDateTimeTimestamp(timestamp)](./foundation-utils.formatdatetimetimestamp.md) | Formats \[DATETIME\] UNIX Timestamps (with time) to readable strings |
|  [formatTimestamp(timestamp, withTime)](./foundation-utils.formattimestamp.md) | Formats \[DATE\|DATETIME\] Unix Timestamps to readable strings |
|  [getDateFormatter(locale, options)](./foundation-utils.getdateformatter.md) |  |
|  [getNumberFormatter(format, locale)](./foundation-utils.getnumberformatter.md) |  |
|  [JSONReplacer(key, value)](./foundation-utils.jsonreplacer.md) | JSON replacer function. |
|  [JSONReviver(key, value)](./foundation-utils.jsonreviver.md) | JSON reviver function. |
|  [reactive(object, deep)](./foundation-utils.reactive.md) | **_(BETA)_** Converts a plain object to a reactive, observable object. |
|  [renderOnChange(target, name)](./foundation-utils.renderonchange.md) | Defines a property changed handler that calls a render() method on the target as an internal observation enhancement. |
|  [sync(binding, conversionType, eventName, keyAttr)](./foundation-utils.sync.md) | Creates a synchronization directive that binds a data source to an HTML element, |
|  [toElementStyles(styles)](./foundation-utils.toelementstyles.md) | toElementStyles. |
|  [visitObject(object, deep, visitor, data, traversed)](./foundation-utils.visitobject.md) | **_(BETA)_** Visit object utility. |
|  [whenElse(binding, trueTemplateOrTemplateBinding, falseTemplateOrTemplateBinding)](./foundation-utils.whenelse.md) | Directive that allows supplying an "else" template to the traditional [https://www.fast.design/docs/api/fast-element.when/\#when-function](https://www.fast.design/docs/api/fast-element.when/#when-function) directive |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [Database](./foundation-utils.database.md) | Represents a database with basic CRUD operations. |
|  [DatabaseRecord](./foundation-utils.databaserecord.md) | Represents a database record. |
|  [DesignSystemModule](./foundation-utils.designsystemmodule.md) | DesignSystemModule. |
|  [DTOMapper](./foundation-utils.dtomapper.md) |  |
|  [ErrorMap](./foundation-utils.errormap.md) |  |
|  [JSONSerializer](./foundation-utils.jsonserializer.md) | An interface representing a JSON serializer. |
|  [JSONSerializerConfig](./foundation-utils.jsonserializerconfig.md) | Configuration options for the JSONSerializer Config instance. |
|  [Logger](./foundation-utils.logger.md) | A logger that extends the <code>Consola</code> logger. |
|  [LoggerOptions](./foundation-utils.loggeroptions.md) | Options for creating a logger. |
|  [ObjectVisitor](./foundation-utils.objectvisitor.md) | **_(BETA)_** |
|  [Observer](./foundation-utils.observer.md) | Represents an event observer that manages the subscription and publication of events. |
|  [ServerRowDTOMapper](./foundation-utils.serverrowdtomapper.md) | A mapper for converting between server row DTOs and entities. Provides methods to get/set a ServerRow DTO entity mapping. |
|  [UUID](./foundation-utils.uuid.md) | An interface for generating UUIDs. |
|  [UUIDConfig](./foundation-utils.uuidconfig.md) | A configuration object for customizing UUID generation. |

## Namespaces

|  Namespace | Description |
|  --- | --- |
|  [DatabaseAccessResult](./foundation-utils.databaseaccessresult.md) | Namespace for database access result types. |
|  [DatabaseEvent](./foundation-utils.databaseevent.md) | Namespace for database events. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [activeColorScheme](./foundation-utils.activecolorscheme.md) | A design token that represents the active color scheme (light or dark). |
|  [API\_HOST](./foundation-utils.api_host.md) | The Genesis Server URL (WebSocket or HTTP). |
|  [createErrorMap](./foundation-utils.createerrormap.md) | A factory to create the error map. |
|  [createObserver](./foundation-utils.createobserver.md) | Creates a new event observer instance. |
|  [DEFAULT\_ORGANISATION](./foundation-utils.default_organisation.md) | The default Organisation value, used in auth/login flow \[<code>genesislcap-foundation-login</code>\](https://link-to-docs). |
|  [DEFAULT\_PASSWORD](./foundation-utils.default_password.md) | The default Password value, used in auth/login flow \[<code>genesislcap-foundation-login</code>\](https://link-to-docs). |
|  [DEFAULT\_USER](./foundation-utils.default_user.md) | The default Username value, used in auth/login flow \[<code>genesislcap-foundation-login</code>\](https://link-to-docs). |
|  [defaultEventMap](./foundation-utils.defaulteventmap.md) | A map that associates specific HTML element tags with their corresponding default event names. |
|  [defaultJSONSerializerConfig](./foundation-utils.defaultjsonserializerconfig.md) | A Default JSONSerializer Config for serializing and deserializing functions. |
|  [defaultLoggerOptions](./foundation-utils.defaultloggeroptions.md) | The default logger options. |
|  [FORCE\_HTTP](./foundation-utils.force_http.md) | The path to a JSON config file for the HTTP mode. |
|  [GENESIS\_SOCKET\_URL](./foundation-utils.genesis_socket_url.md) | Genesis Socket URL |
|  [getFontMixin](./foundation-utils.getfontmixin.md) | Generates a CSS mixin for the specified font family, style, and weight. |
|  [HTTP\_CONFIG](./foundation-utils.http_config.md) | Configuration settings for HTTP, used in http connect flow \[<code>genesislcap-foundation-comms.HttpConnectConfig</code>\](https://link-to-docs). |
|  [inIFrame](./foundation-utils.iniframe.md) | Returns a boolean value indicating whether the current window is inside an iframe. |
|  [insertDocumentCSSRule](./foundation-utils.insertdocumentcssrule.md) | Inserts a CSS rule into the document by creating a new style element or using an existing one with the specified ID. Returns a function that can be called to remove the rule from the document. |
|  [insertDocumentLink](./foundation-utils.insertdocumentlink.md) | Inserts a CSS link into the document if it doesn't already exist. |
|  [inSymphonyDesktop](./foundation-utils.insymphonydesktop.md) | Returns a boolean value indicating whether the user is running the Symphony desktop app. |
|  [isDev](./foundation-utils.isdev.md) | Determines if the current environment is a development environment. |
|  [JSONSerializer](./foundation-utils.jsonserializer.md) | A DI token for the JSON serializer. |
|  [layoutCacheDocument](./foundation-utils.layoutcachedocument.md) | Stored on the layout's internal cache to signify that the document is not part of the DOM |
|  [LifecycleMixin](./foundation-utils.lifecyclemixin.md) | **_(BETA)_** Mixin class to expose <code>shouldRunConnect</code> and <code>shouldRunDisconnect</code> |
|  [loadFontFaces](./foundation-utils.loadfontfaces.md) | Loads font faces by inserting a style element with the specified font face rules into the document. |
|  [openPopup](./foundation-utils.openpopup.md) | Opens a new browser window with the specified URL, target, width, and height. |
|  [PendingState](./foundation-utils.pendingstate.md) | The <code>PendingState</code> mixin. |
|  [POPUP\_DEFAULT\_HEIGHT](./foundation-utils.popup_default_height.md) | The default height (in pixels) for pop-up windows. |
|  [POPUP\_DEFAULT\_WIDTH](./foundation-utils.popup_default_width.md) | The default width (in pixels) for pop-up windows. |
|  [resolveAfter](./foundation-utils.resolveafter.md) | Resolve a promise after a timeout. |
|  [ResourceType](./foundation-utils.resourcetype.md) | An object that defines two resource types: "local" and "remote". |
|  [respondToVisibility](./foundation-utils.respondtovisibility.md) | Setup an <code>IntersectionObserver</code> which will activate a callback function when an element becomes visible on screen |
|  [ServerRowDTOMapper](./foundation-utils.serverrowdtomapper.md) | A DI token used to obtain a <code>ServerRowDTOMapper</code> instance. |
|  [SOCKET\_EXT](./foundation-utils.socket_ext.md) | The sub-path used for WebSocket connections when API\_HOST is not set |
|  [TypeRampValues](./foundation-utils.typerampvalues.md) | An object containing type ramp values. |
|  [UUID](./foundation-utils.uuid.md) | A dependency injection token for the UUID interface. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [ConstructableLifecycleHandler](./foundation-utils.constructablelifecyclehandler.md) |  |
|  [ConstructablePendingState](./foundation-utils.constructablependingstate.md) | A mixin that provides functionality for raising <code>pending-state</code> events. |
|  [ConversionType](./foundation-utils.conversiontype.md) | Represents the possible types of value conversion for data synchronization. |
|  [DesignSystemResource](./foundation-utils.designsystemresource.md) | DesignSystemResource. |
|  [ErrorDetailMap](./foundation-utils.errordetailmap.md) |  |
|  [ErrorMapLogger](./foundation-utils.errormaplogger.md) |  |
|  [EventName](./foundation-utils.eventname.md) | Represents the possible event names for data synchronization. |
|  [Listener](./foundation-utils.listener.md) | Creates an observer that facilitates the subscription and publication of events. |
|  [PendingStateErrorEvent](./foundation-utils.pendingstateerrorevent.md) | A custom event that represents a <code>pending-state-error</code> event. |
|  [PendingStateEvent](./foundation-utils.pendingstateevent.md) | A custom event that represents a <code>pending-state</code> event. |
|  [Publish](./foundation-utils.publish.md) | Publishes an event of a specific type to all subscribed listeners. |
|  [ResourceType](./foundation-utils.resourcetype.md) | A type that represents the resource types defined by the <code>ResourceType</code> object. |
|  [ServerRowDTO](./foundation-utils.serverrowdto.md) | The data for a server row DTO. |
|  [ServerRowEntity](./foundation-utils.serverrowentity.md) | The data for a server row entity. |
|  [Subscribe](./foundation-utils.subscribe.md) | Subscribes a listener function to receive events of a specific type. |

