<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-utils](./foundation-utils.md) &gt; [ObjectVisitor](./foundation-utils.objectvisitor.md)

## ObjectVisitor interface

> This API is provided as a beta preview for developers and may change based on feedback that we receive. Do not use this API in a production environment.
> 

**Signature:**

```typescript
export interface ObjectVisitor<TVisitorData> 
```

## Example

Reactive visitor example.

```ts
const makeObserverVisitor: ObjectVisitor<undefined> = {
  visitObject: noop,
  visitArray: noop,
  visitProperty(object: any, propertyName: string, value: any): void {
    Reflect.defineProperty(object, propertyName, {
      enumerable: true,
      get() {
        Observable.track(object, propertyName);
        return value;
      },
      set(newValue: any) {
        if (value !== newValue) {
          value = newValue;
          Observable.notify(object, propertyName);
        }
      },
    });
  },
};
```

## Methods

|  Method | Description |
|  --- | --- |
|  [visitArray(array, data)](./foundation-utils.objectvisitor.visitarray.md) | **_(BETA)_** |
|  [visitObject(object, data)](./foundation-utils.objectvisitor.visitobject.md) | **_(BETA)_** |
|  [visitProperty(object, key, value, data)](./foundation-utils.objectvisitor.visitproperty.md) | **_(BETA)_** |

